<template>
  <el-dialog
    :title="!dataForm.id ? '新增' : '修改'"
    :close-on-click-modal="false"
    :visible.sync="visible">
    <el-form :model="dataForm" :rules="dataRule" ref="dataForm" @keyup.enter.native="handleConfirm()"
             label-width="80px">

      <el-form-item label="角色名称" prop="roleName">
        <el-input v-model="dataForm.roleName" placeholder=""></el-input>
      </el-form-item>

      <el-form-item size="mini" label="授权">
        <el-tree
          :data="menuList"
          :props="menuListTreeProps"
          node-key="menuId"
          ref="menuListTree"
          :default-expand-all="true"
          :default-checked-keys="defaultCheckedKeys"
          :filter-node-method="filterNode"
          show-checkbox
        >
          <span class="custom-tree-node" slot-scope="{ node, data }">
            <span>{{ node.label }}</span>
          </span>
        </el-tree>
      </el-form-item>


    </el-form>
    <span slot="footer" class="dialog-footer">
      <el-button @click="visible = false">取消</el-button>
      <el-button type="primary" @click="handleConfirm()">确定</el-button>
    </span>
  </el-dialog>
</template>


<script>
import {treeDataTranslate} from '@/utils'
import {apiSysMenuList, apiSysRoleInfo, apiSysRoleConfirm} from '@/api/api_role'

export default {
  data () {
    return {
      visible: false,
      menuList: [],
      menuListTreeProps: {
        label: 'name',
        children: 'children'
      },
      tempKey: -666666, // 临时key, 用于解决tree半选中状态项不能传给后台接口问题. # 待优化
      defaultCheckedKeys: [],
      apiType: '', // api类型
      dataForm: {
        roleName: ''
      },
      dataRule: {

      }
    }
  },
  methods: {
    async init (id) {
      this.dataForm.id = id || 0
      this.visible = true
      this.dataForm = {}
      if (id) {
        await this.handleGetSysMenuList()
        this.dataForm.id = id || 0
        this.handleEdit()
        this.apiType = '/update'
      } else {
        await this.handleGetSysMenuListAdd()
        this.apiType = '/save'
      }
    },
    // 获取权限列表
    async handleGetSysMenuList () {
      let res = await apiSysMenuList({})
      this.menuList = treeDataTranslate(res, 'menuId')
      this.visible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].resetFields()
        this.$refs.menuListTree.setCheckedKeys([])
      })
    },
    // 获取权限列表
    async handleGetSysMenuListAdd () {
      let res = await apiSysMenuList({})
      this.menuList = treeDataTranslate(res, 'menuId')
      this.visible = true
      this.$nextTick(() => {
        this.$refs.menuListTree.setCheckedKeys([])
      })
    },
    filterNode (value, data) {
      console.log('data: ', data)
      console.log('value: ', value)
      data.disabled = true
      return value.includes(data.menuId)
    },
    // 编辑
    handleEdit () {
      apiSysRoleInfo({}, `/${this.dataForm.id}`).then(res => {
        if (res && res.code === 0) {
          this.dataForm = Object.assign({}, this.dataForm, res.role)
          var idx = res.role.menuIdList.indexOf(this.tempKey)
          if (idx !== -1) {
            res.role.menuIdList.splice(idx, res.role.menuIdList.length - idx)
          }
          if (this.disable) {
            this.$refs.menuListTree.filter(res.role.menuIdList)
          }
          this.defaultCheckedKeys = res.role.menuIdList
        }
      })
    },
    // 提交
    handleConfirm () {
      if (this.disable) {
        this.visible = false
        return
      }
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          let params = {
            'roleId': this.dataForm.id || undefined,
            'roleName': this.dataForm.roleName,
            'remark': this.dataForm.remark,
            'menuIdList': [].concat(this.$refs.menuListTree.getCheckedKeys(), [this.tempKey], this.$refs.menuListTree.getHalfCheckedKeys())
          }
          apiSysRoleConfirm(params, this.apiType).then(res => {
            if (res && res.code === 0) {
              this.$message({
                message: '操作成功',
                type: 'success',
                duration: 1500,
                onClose: () => {
                  this.visible = false
                  this.$emit('refreshDataList')
                }
              })
            } else {
              this.$message.error(res.msg)
            }
          })
        }
      })
    }
  }
}
</script>
